#ifndef __TEXTURE2D_H__
#define __TEXTURE2D_H__

#include "texture.h"

namespace moglclass
{

class Texture2D : public Texture
{
public:
	Texture2D(int wrap=GL_REPEAT, int min=GL_LINEAR, int mag=GL_LINEAR);
	Texture2D(const char *filename, int wrap=GL_REPEAT, int min=GL_LINEAR, int mag=GL_LINEAR);
	virtual ~Texture2D(void);
    virtual void bind(int num=0);
    virtual void disable(void);
    virtual void release(void);

	bool load(const char *filename, bool mipmaps = false);
	void subload(GLuint xoffset=0, GLuint yoffset=0);

    unsigned int getTextureID(void) { return uiTexture; }
	unsigned int getSamplerID(void) { return uiSampler; }
	void setSamplerParameter(GLenum parameter, GLenum value);

private:
	unsigned char * imageData;
	unsigned char * rescaledImageData;
    int width, height, numComponents;
	GLenum type;

    GLuint uiTexture;
	GLuint uiSampler;
};

} // namespace

#endif
